package Uebung06;

import java.util.Scanner;

/**
 * <h1>Übung 06, Aufgabe 01</h1>
 *
 * <p>Programmieren 1
 * Wintersemester 2021/-22
 * HS-Bremerhaven
 * Prof. Dr. Peter Kelb</p>
 *
 * <p>Stellen Sie Ihr Life Programm auf Methoden um.
 * Die Initialisierung, Ausgabe und Neuberechnung soll jeweils durch eine
 * Methode erfolgen.</p>
 * <p>Verändern Sie die Definition für die Nachbarschaft. Jetzt sollen auch die Zellen
 * am Rand und in den Ecken jeweils 8 Nachbarn haben. Dazu hat der linke Rand
 * als linken Nachbarn den ganz rechten Rand, die oberen Zellen als oberen
 * Nachbarn die ganz unteren Zellen usw. D.h. geht man oben aus dem Feld
 * hinaus, kommt man unten wieder hinein, geht man links heraus, kommt man
 * rechts wieder hinein.</p>
 * <p>Führen Sie die Neuberechnung und Ausgabe immer wieder durch.</p>
 *
 * @author franjogiessel
 */
public class Aufgabe01 {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in); // neues Scanner-Objekt sc

        System.out.print("Anzahl Zeilen: ");
        int zeilen = sc.nextInt();
        System.out.print("Anzahl Spalten: ");
        int spalten = sc.nextInt();

        boolean[][] ausgabe = initializeArray(zeilen, spalten);
        printArray(ausgabe);

        for (int i = 0; i < spalten; i++) {
            System.out.print('-');
        }
        System.out.println();

        boolean[][] neueAusgabe = recalculateArray(ausgabe);
        printArray(neueAusgabe);
    }

    /**
     * Initialisiert ein zweidimensionales-boolean-Array nach den gegebenen Vorgaben.
     * Die Größe wird duch die Parameter festgelegt.
     * @param zeilen Anzahl Zeilen des Arrays
     * @param spalten Anzahl Spalen des Arrays
     * @return zweidimensionales-boolean-Array nach den gegebenen Vorgaben.
     */
    public static boolean[][] initializeArray(int zeilen, int spalten) {
        boolean[][] ausgabe = new boolean[zeilen][spalten];

        // Array betanken
        for (int i = 0; i < ausgabe.length; ++i) {
            for (int j = 0; j < ausgabe[i].length; ++j) {
                ausgabe[i][j] = j % (i + 2) == 0;
            }
        }
        return ausgabe;
    }

    /**
     * Gibt das übergebene zweidimensionale-boolean-Array zeilenweise auf StOut aus.
     * @param ausgabe Auszugebenes zweidimensionales-boolean-Array
     */
    public static void printArray(boolean[][] ausgabe) {
        // Array ausgeben
        for (boolean[] zeile : ausgabe) { // Die Objekte von ausgabe[][] sind zeile[]
            for (boolean zelle : zeile) { // Die Objekte von zeile[] sind zelle
                System.out.print(zelle ? 'T' : 'F');
            }
            System.out.println();
        }
    }

    /**
     * Berechnet das neue zweidimensionale-boolean-Array nach den neuen Vorgaben.
     * @param ausgabe Ausgangs-zweidimensionales-boolean-Array
     * @return neues zweidimensionales-boolean-Array nach den neuen Voragaben.
     */
    public static boolean[][] recalculateArray(boolean[][] ausgabe) {
        // neues Ausgabe-Array erstellen mit derselben Größe, wie das Ausgangsarray
        boolean[][] neueAusgabe = new boolean[ausgabe.length][ausgabe[1].length];

        // Array betanken
        for (int i = 0; i < neueAusgabe.length; ++i) {
            for (int j = 0; j < neueAusgabe[i].length; ++j) {

                // Nachbarschaft berechnen
                int nachbarschaft = getNeighborhood(ausgabe, i, j);

                // neuen Wert entsprechend der vorgegebenen Regeln setzen
                neueAusgabe[i][j] = nachbarschaft == 3 || (nachbarschaft == 2 && ausgabe[i][j]);
            }
        }
        return neueAusgabe;
    }

    /**
     * Berechnet die Nachbarschaft der durch zeile und spalte definierte Zelle nach den neuen Vorgaben.
     * @param ausgabe Ausgangs-zweidimensionales-boolean-Array, auf die die Berechnung der Nachbarschaft basiert.
     * @param zeile zeile der zu berechnenden Zelle
     * @param spalte spalte der zu berechnenden Zelle
     * @return berechnete Nachbarschaft nach den neuen Voragaben.
     */
    private static int getNeighborhood(boolean[][] ausgabe, int zeile, int spalte) {
        int nachbarschaft = 0;

        for (int i = -1; i < 2; ++i) {
            for (int j = -1; j < 2; ++j) {
                if ((i != 0 || j != 0) && (ausgabe[(zeile + i + ausgabe.length) % ausgabe.length][(spalte + j + ausgabe[zeile].length) %55ausgabe[zeile].length])) {
                    ++nachbarschaft;
                }
            }
        }


        // N N N x   // zeile = A-1, spalte = B-1, B, B+1
        // N Y N x   // zeile = A,   spalte = B-1,    B+1
        // N N N x   // zeile = A+1, spalte = B-1, B, B+1
        // x x x x
//
//
//        // prüfe oben
//        if (ausgabe[Math.floorMod(zeile-1, ausgabe.length)][spalte]) ++nachbarschaft;
//
//        if (ausgabe[zeile-1 + ausgabe.length % ausgabe.length][spalte]) ++nachbarschaft;
//
//
//        // prüfe oben rechts
//        if (ausgabe[Math.floorMod(zeile-1, ausgabe.length)][Math.floorMod(spalte+1, ausgabe[zeile].length)]) ++nachbarschaft;
//
//        // prüfe rechts
//        if (ausgabe[zeile][Math.floorMod(spalte+1, ausgabe[zeile].length)]) ++nachbarschaft;
//
//        // prüfe unten rechts
//        if (ausgabe[Math.floorMod(zeile+1, ausgabe.length)][Math.floorMod(spalte+1, ausgabe[zeile].length)]) ++nachbarschaft;
//
//        // prüfe unten
//        if (ausgabe[Math.floorMod(zeile+1, ausgabe.length)][spalte]) ++nachbarschaft;
//
//        if (ausgabe[(zeile+1 + ausgabe.length) % ausgabe.length][spalte]) ++nachbarschaft;
//
//
//        // prüfe unten links
//        if (ausgabe[Math.floorMod(zeile+1, ausgabe.length)][Math.floorMod(spalte-1, ausgabe[zeile].length)]) ++nachbarschaft;
//
//        // prüfe links
//        if (ausgabe[zeile][Math.floorMod(spalte-1, ausgabe[zeile].length)]) ++nachbarschaft;
//
//        // prüfe oben links
//        if (ausgabe[Math.floorMod(zeile-1, ausgabe.length)][Math.floorMod(spalte-1, ausgabe[zeile].length)]) ++nachbarschaft;

        return nachbarschaft;
    }
}