package Uebung06;

/**
 * <h1>Übung 06, Aufgabe 02</h1>
 *
 * <p>Programmieren 1
 * Wintersemester 2021/-22
 * HS-Bremerhaven
 * Prof. Dr. Peter Kelb</p>
 *
 * <p>Erweitern Sie Ihr Rational Programm derart, dass die beiden Zahlen einmal
 * addiert und einmal multipliziert werden. Speichern Sie die Werte erneut in int-
 * Arrays der Länge zwei ab. Geben Sie die Ergebnisse einmal vor dem Kürzen
 * und einmal nach dem Kürzen aus.</p>
 *
 * @author franjogiessel
 */
public class Aufgabe02 {

    public static void main(String[] args) {
        int zahl0[] = {4, 6};
        int zahl1[] = {15, 24};

        int[] neuZahl0 = bruchKuerzen(zahl0);
        System.out.printf(" zahl0 = %d / %d%n", neuZahl0[0], neuZahl0[1]);

        int[] neuZahl1 = bruchKuerzen(zahl1);
        System.out.printf(" zahl1 = %d / %d%n", neuZahl1[0], neuZahl1[1]);

        int summe[] = bruecheAddieren(zahl0, zahl1);
        int produkt[] = bruecheMultiplizieren(zahl0, zahl1);

        System.out.println(" Summe = " + summe[0] + " / " + summe[1]);
        System.out.println(" Produkt = " + produkt[0] + " / " + produkt[1]);

        summe = bruchKuerzen(summe);
        produkt = bruchKuerzen(produkt);

        System.out.println(" Summe gekürzt = " + summe[0] + " / " + summe[1]);
        System.out.println(" Produkt gekürzt = " + produkt[0] + " / " + produkt[1]);
    }

    /**
     * Berechnet den größten gemeinsamen Teiler (ggT) der Zahlen a und b und gibt diesen wieder zurück.
     * @param a Erste Zahl
     * @param b Zweite Zahl
     * @return größten gemeinsamen Teiler.
     */
    public static int ggt (int a, int b) {
        // Die größere der beiden Zahlen muss als erstes an den Algorithmus übergeben werden.
        int va = a > b ? a : b;
        int vb = a > b ? b : a;
        int r = 1, vr = 1;
        while (r != 0) {
            vr = r;
            r = va % vb;
            va = vb;
            vb = r;
        }
        return vr;
    }

    /**
     * Kürzt den übergebenen Bruch. Der erste Wert des Arrays ist der Zähler, der zweite Wert ist der Nenner.
     * @param bruch Der zu kürzende Bruch. Der erste Wert des Arrays ist der Zähler, der zweite Wert ist der Nenner.
     * @return Gekürzter Bruch.
     */
    public static int[] bruchKuerzen (int[] bruch) {
        int ggt0 = ggt(bruch[0], bruch[1]);
        int[] result = {bruch[0] / ggt0, bruch[1] / ggt0};
        return result;
    }

    /**
     * Berechnet die Summe zweier Brüche und gibt den ungekürzten Bruch zurück.
     * @param zahl0 Die erste Zahl. Der erste Wert des Arrays ist der Zähler, der zweite Wert ist der Nenner.
     * @param zahl1 Die zweite Zahl. Der erste Wert des Arrays ist der Zähler, der zweite Wert ist der Nenner.
     * @return Summierter Bruch.
     */
    public static int[] bruecheAddieren (int[] zahl0, int[] zahl1) {
        int[] summe = {zahl0[0]*zahl1[1]+zahl1[0]*zahl0[1], zahl0[1]*zahl1[1]};
        return summe;
    }

    /**
     * Berechnet das Produkt zweier Brüche und gibt den ungekürzten Bruch zurück.
     * @param zahl0 Die erste Zahl. Der erste Wert des Arrays ist der Zähler, der zweite Wert ist der Nenner.
     * @param zahl1 Die zweite Zahl. Der erste Wert des Arrays ist der Zähler, der zweite Wert ist der Nenner.
     * @return Multiplizierter Bruch.
     */
    public static int[] bruecheMultiplizieren (int[] zahl0, int[] zahl1) {
        int[] produkt = {zahl0[0]*zahl1[0], zahl0[1]*zahl1[1]};
        return produkt;
    }
}
